/////////////////////////////////////////////////////////////
// esqconvert / mdxconvert                                 //
// converts .ESQ and .MDX to SQ80 Toolkit bank dump format //
// written in 1999 by Rainer Buchty (rainer@buchty.net)    //
/////////////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>

FILE *fd;
char buffer[8192], nambuf[10], name[14];
int i;

int main(int argc, char **argv){
	// as what have I been called?
	if (strcmp("esqconvert",*argv)==0) 
		strcpy(name,"esqconvert");
	else 
		strcpy(name,"mdxconvert");
	
	argc--; argv++;
	
	if (argc!=1) {
		printf("Usage: %s file\n",name);
		exit(-1);
	}
	
	if ((fd=fopen(*argv,"r"))==NULL) {
		printf("Can't read file.\n");
		exit(-1);
	}
	
	if (fread(buffer,1,8166,fd)!=8166) {
		printf("Short file.\n");
		fclose(fd);
		exit(-1);
	}
	fclose(fd);

		
	// use file name as bank name 
	memset(&nambuf,32,10);
	if ((strlen(*argv)-4)<10) 
		memcpy(&nambuf,*argv,strlen(*argv)-4);
	else
		memcpy(&nambuf,*argv,10);
		
	// create header
	printf("!SQ80BANK!%c%c%c",2,0,0);
	for(i=0;i<10;i++) printf("%c",toupper(nambuf[i]));
	
	// do conversion
	for(i=5;i<8165;i+=2) 
		printf("%c",(buffer[i+1]<<4)|buffer[i]);

	exit(0);
}		
	
	
		