/* some floppies - such as mine - don't seek fast enough */
#define SLOW_FLOPPY	1

/* standard file types */
#define FREE    0       /* unused */
#define OS      1       /* operating system */
#define BNK     2       /* program bank */
#define SNG     3       /* all sequence (song) */
#define SEQ     4       /* one sequence */
#define SYX     5       /* system exclusive */
#define PRG     6       /* single program */

/* my own definitions */
#define ASX     7       /* all seq/syx */
#define ALL     8       /* all files */
#define UDEF    9       /* undefined */

/* standard file type extensions */
static char *ft_ext[]={
        "---",
        "SYS",
        "BNK",
        "SNG",
        "SEQ",
        "SYX",
        "PRG"
};

static char *ft_hdr[]={
	0,
	"!SQ80OSYS!",
	"!SQ80BANK!",
	"!SQ80SONG!",
	"!SQ80SEQU!",
	"!SQ80SYSX!",
	"!SQ80PROG!"
};

/* directory structure */
typedef struct sqdp {
        int c;
        int h;
        int s;
} sqdp_t;

/* directory position */
sqdp_t dirpos[4]={ {0,0,5},{0,1,5},{1,1,5},{1,0,5} };

/* directory entry */
typedef struct directory_entry {
        char type;
        char name[10];
        int size;
} de_t;

static de_t diskdir[178],filedir[178];
static char dirbuf[2048];

/* file position structure */
typedef struct disk_geometry {
        char st,sh,ss;  /* starting track/head/sector */
        char et,eh,es;  /* ending track/head/sector */
} geo_t;

/* file position */
static geo_t geo[]={
        { 0,0,0, 6,0,3},        /* seqram #1  */
        { 6,0,4,12,1,2},        /* seqram #2  */
        {12,0x11,3,19,1,1},     /* seqram #3  */
        {19,1,2,25,0,0},        /* seqram #4  */
        {25,0x10,1,31,0,4},     /* seqram #5  */
        {32,0,0,38,0,3},        /* seqram #6  */
        {38,0,4,44,1,2},        /* seqram #7  */
        {44,0x11,3,51,1,1},     /* seqram #8  */
        {57,1,2,57,0,0},        /* seqram #9  */
        {57,0x10,1,63,0,4},     /* seqram #10 */
        {64,0,0,64,0,3},        /* bank #1  */
        {64,0,4,65,0,2},        /* bank #2  */
        {65,0,3,66,0,1},        /* bank #3  */
        {66,0,2,67,0,0},        /* bank #4  */
        {67,0,1,67,0,4},        /* bank #5  */
        {68,0,0,68,0,3},        /* bank #6  */
        {68,0,4,69,0,2},        /* bank #7  */
        {69,0,3,70,0,1},        /* bank #8  */
        {70,0,2,71,0,0},        /* bank #9  */
        {71,0,1,71,0,4},        /* bank #10 */
        {72,0,0,72,0,3},        /* bank #11 */
        {72,0,4,73,0,2},        /* bank #12 */
        {73,0,3,74,0,1},        /* bank #13 */
        {74,0,2,75,0,0},        /* bank #14 */
        {75,0,1,75,0,4},        /* bank #15 */
        {76,0,0,76,0,3},        /* bank #16 */
        {76,0,4,77,0,2},        /* bank #17 */
        {77,0,3,78,0,1},        /* bank #18 */
        {78,0,2,79,0,0},        /* bank #19 */
        {79,0,1,79,0,4},        /* bank #20 */
        {64,1,0,64,1,3},        /* bank #21 */
        {64,1,4,65,1,2},        /* bank #22 */
        {65,1,3,66,1,1},        /* bank #23 */
        {66,1,2,67,1,0},        /* bank #24 */
        {67,1,1,67,1,4},        /* bank #25 */
        {68,1,0,68,1,3},        /* bank #26 */
        {68,1,4,69,1,2},        /* bank #27 */
        {69,1,3,70,1,1},        /* bank #28 */
        {70,1,2,71,1,0},        /* bank #29 */
        {71,1,1,71,1,4},        /* bank #30 */
        {72,1,0,72,1,3},        /* bank #31 */
        {72,1,4,73,1,2},        /* bank #32 */
        {73,1,3,74,1,1},        /* bank #33 */
        {74,1,2,75,1,0},        /* bank #34 */
        {75,1,1,75,1,4},        /* bank #35 */
        {76,1,0,76,1,3},        /* bank #36 */
        {76,1,4,77,1,2},        /* bank #37 */
        {77,1,3,78,1,1},        /* bank #38 */
        {78,1,2,79,1,0},        /* bank #39 */
        {79,1,1,79,1,4}         /* bank #40 */
};

/* cursor stuff */
static char *SUL="\033[4m";
static char *EUL="\033[24m";
static char *BOLD="\0[1m";
static char *NORM="\0[m\017";

/* floppy devices */
static char *floppy[]={
        "/dev/fd0",
        "/dev/fd1",
        "/dev/fd2",
        "/dev/fd3"
};

